// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type UploadInfo struct {
	FileSize int64  `form:"file_size,optional"` // 上传唯一标识信息
	FileKeys string `form:"file_keys,optional"` // 上传唯一标识信息
	Metadata string `form:"meta_data,optional"` // 上传文件额外信息
}

type UploadFilesReq struct {
	ApiType      int64  `form:"api_type,options=[1,2],default=1"`      // 调用类型：1=对外，2=对内
	UploadBucket int64  `form:"upload_bucket,options=[1,2],default=1"` // 上传桶名:1=缓存,2=持久
	UploadInfo   string `form:"upload_info"`                           // 上传信息 json
}

type UploadCallbackReq struct {
	FileType     string `form:"file_type"`         // 文件类型 / fbx / hdr
	UploadKey    string `form:"upload_key"`        // 上传KEY
	UploadBucket string `form:"upload_bucket"`     // 上传桶名
	Version      string `form:"version,optional"`  // 版本信息
	Metadata     string `form:"metadata,optional"` // 元数据,json格式,存储图像分率
}

type RequestUpFile struct {
	UpFile string `form:"upfile"`
	IsCut  string `form:"is_cut"` // 是否裁剪
}

type RequestUploadFileFrontend struct {
	FileName string `json:"file_name"` // 文件名
	FileType string `json:"file_type"` // Image / fbx / hdr
	FileSize int64  `json:"file_size"` // 文件大小
	Category string `json:"category"`  // 类别
}

type RequestUploadFileBackend struct {
	File     File   `file:"file"`      // 文件名
	FileType string `form:"file_type"` // Image / fbx / hdr
	Category string `form:"category"`  // 类别
}

type UploadQrcodeReq struct {
	Url        string `json:"url"`
	QRcodeType int64  `json:"QRcodeType"`
}

type UploadQrcodeRsp struct {
	Link string `json:"link"`
	Data string `json:"d"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"totalCount"`
	PageCount   int64 `json:"pageCount"`
	CurrentPage int   `json:"currentPage"`
	PerPage     int   `json:"perPage"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
